-- Part of SmallEiffel -- Read DISCLAIMER file -- Copyright (C) 
-- Dominique COLNET and Suzanne COLLIN -- colnet@loria.fr
class STD_FILE_READ_WRITE
   --
   -- Originally written by Emmanuel CECCHET --
   --
inherit 
   STD_FILE_READ
      undefine connect_to, disconnect 
      redefine read_character, end_of_input
      end;
   STD_FILE_WRITE
      redefine connect_to, put_character
      end;
   
creation connect_to
   
feature 
   
   connect_to(new_path: STRING) is
      local
	 rewrite_fic : STD_FILE_WRITE ;
      do
	 mode := "r+";
	 input_stream := fopen(new_path,mode);
	 if input_stream /= Void then
	    path := new_path;
	    output_stream := input_stream;
	 end;
      end;
   
   read_character is
      do
	 flush_stream(output_stream);
	 last_fgetc := fgetc(input_stream);
      end;
   
   put_character(c: CHARACTER) is
      do
	 flush_stream(output_stream);
	 write_byte(output_stream,c);
      end;
   
   end_of_input: BOOLEAN is
      do
	 flush_stream(output_stream);
	 Result := feof(input_stream)
      end;

feature {NONE}

   feof(stream_ptr: POINTER): BOOLEAN is
      external "SmallEiffel"
      end;

end -- STD_FILE_READ_WRITE

