-- Part of SmallEiffel -- Read DISCLAIMER file -- Copyright (C) 
-- Dominique COLNET and Suzanne COLLIN -- colnet@loria.fr
--
class STD_INPUT
--
-- To use the standard input file. As for UNIX, the default standard 
-- input is the keyboard.
--
-- Notes : - the predefined `std_input' should be use to have only 
--         one instance of the class STD_INPUT. 
--         - to do reading or writing at the same time on the screen, 
--         see STD_INPUT_OUTPUT,
--         - to handle cursor of the screen, see CURSES.
--
   
inherit INPUT_STREAM;
   
creation make, connect_to

feature {NONE}

   memory: INTEGER;
	 -- Memory of the last available user's value.

feature

   is_connected: BOOLEAN is true;

feature 
   
   make is
      do
      end;
   
feature

   read_character is
      do
	 if push_back_flag then
	    push_back_flag := false;
	 else
	    memory := fgetc(stdin);
	 end;
      end;

   unread_character is
      do
	 push_back_flag := true;
      end;

   last_character: CHARACTER is
      do
	 Result := memory.to_character;
      end;

   end_of_input: BOOLEAN is
      do
	 if not push_back_flag then
	    Result := memory = eof_code;
	 end;
      end;

   read_line_in(str: STRING) is
      local
	 mem: INTEGER;
      do
	 read_character;
	 if last_character /= '%N' then
	    from  
	       str.extend(memory.to_character);
	       mem := fgetc(stdin);
	    until
	       mem = eof_code or else mem = ('%N').code
	    loop
	       str.extend(mem.to_character);
	       mem := fgetc(stdin);
	    end;
	    if mem = eof_code then
	       memory := eof_code;
	    else
	       memory := fgetc(stdin);
	    end;
	 end;
      end;

feature {NONE} 
   
   stdin: POINTER is
      external "SmallEiffel"
      end;

end
