-- Part of SmallEiffel -- Read DISCLAIMER file -- Copyright (C) 
-- Dominique COLNET and Suzanne COLLIN -- colnet@loria.fr
--
class STD_OUTPUT
--
-- To use the standard output file. As for UNIX, the default standard 
-- output is the screen.
--
-- Notes: - the predefined `std_output' should be use to have only one instance 
--        of the class STD_OUTPUT,
--        - to do reading or writing at the same time on the screen, 
--        see STD_INPUT_OUTPUT,
--
   
inherit OUTPUT_STREAM;
   
creation make

feature
   
   is_connected: BOOLEAN is true;

feature

   make is
      do
      end;

feature

   put_character(c: CHARACTER) is
      do
	 write_byte(stdout,c);
      end;

   flush is
      do
	 flush_stream(stdout);
      end;

feature {NONE}
   
   stdout: POINTER is
      external "SmallEiffel"
      end;

end
