-- Part of SmallEiffel -- Read DISCLAIMER file -- Copyright (C) 
-- Dominique COLNET and Suzanne COLLIN -- colnet@loria.fr
--
deferred class AUX_JMJ3C2D[T]
feature

   dimension(first_dim, second_dim, tile_width: INTEGER) is
      require
	 positive_dim1: first_dim > 0
	 positive_dim2: second_dim > 0
	 non_negative_tile: tile_width >= 0
      deferred
      ensure
	 dim1 = first_dim+2*tile_width
	 dim2 = second_dim+2*tile_width
      end 

   dim1, dim2: INTEGER is
      deferred
      end 

   lower1, lower2: INTEGER is
      deferred
      end 

   upper1, upper2: INTEGER is 
      deferred
      end 

   valid_index(i, j: INTEGER): BOOLEAN is
      do
         Result := (lower1<=i and i<=upper1 and lower2<=j and j<=upper2)
      end

   count: INTEGER is
      do
         Result := (upper1-lower1+1)*(upper2-lower2+1)
      end

  empty: BOOLEAN is
      do
         Result := (count = 0)
      end

feature 

   item(i,j: INTEGER): T is
      require
	 valid_index(i,j)
      deferred
      end

feature 

   put(element: T; i,j : INTEGER) is
      require
	 valid_index(i,j)
      deferred
      ensure
	 element = item(i,j)
      end

end -- AUX_JMJ3C2D
