-- Part of SmallEiffel -- Read DISCLAIMER file -- Copyright (C) 
-- Dominique COLNET and Suzanne COLLIN -- colnet@loria.fr
--
class TEST_BIT18

creation make
   
feature
   
   ab1, ab2: BIT 70;

   make is 
      local
         lb1, lb2: BIT 70;
      do
	 -- Testing local bits :
	 lb1 := bit70;
	 is_true(lb2 /= lb1);
	 is_true(not (lb2 = lb1));
	 lb2 := bit70;
	 is_true(lb1 = lb2);
	 is_true(not (lb1 /= lb2));

	 lb2.put(false,3);
	 is_true(lb1 /= lb2);
	 is_true(not (lb1 = lb2));

	 -- Testing attributes bits :
	 ab1 := bit70;
	 is_true(ab2 /= ab1);
	 is_true(not (ab2 = ab1));
	 ab2 := bit70;
	 is_true(ab1 = ab2);
	 is_true(not (ab1 /= ab2));

	 ab2.put(false,3);
	 is_true(ab1 /= ab2);
	 is_true(not (ab1 = ab2));

	 
	 -- Testing both attribute/local bits :
	 lb1 := bit70;
	 is_true(ab2 /= lb1);
	 is_true(not (ab2 = lb1));
	 ab2 := bit70;
	 is_true(lb1 = ab2);
	 is_true(not (lb1 /= ab2));

	 ab2.put(false,3);
	 is_true(lb1 /= ab2);
	 is_true(not (lb1 = ab2));

	 -- Testing constant :
	 lb1 := bit70;
	 is_true(lb1 = bit70);
      end;

feature {NONE}

   bit70: BIT 70 is
    0011111111111000101010101111111100100100100100000000111111111111111111B;

   is_true(b: BOOLEAN) is
      do
	 cpt := cpt + 1;
	 if not b then
	    std_output.put_string("TEST_BIT18: ERROR Test # ");
	    std_output.put_integer(cpt);
	    std_output.put_string("%N");
	    crash;
	 else
	    -- std_output.put_string("Yes%N");
	 end;
      end;
   
   cpt: INTEGER;
   
end

