-- Part of SmallEiffel -- Read DISCLAIMER file -- Copyright (C) 
-- Dominique COLNET and Suzanne COLLIN -- colnet@loria.fr
--
class TEST_CLONE1

   -- Test feature `set_all_with' of various implementations.

creation make
   
feature 
   
   make is
      local
	 a: ARRAY[INTEGER];
	 fa: FIXED_ARRAY[INTEGER];
	 ll: LINK_LIST[INTEGER];
	 l2l: LINK2_LIST[INTEGER];
      do
	 a := clone(model1a);
	 test(a,model1a);
	 a := clone(model2a);
	 test(a,model2a);
	 a := clone(model3a);
	 test(a,model3a);
	 a := clone(model4a);
	 test(a,model4a);
	 
	 fa := clone(model1fa);
	 test(fa,model1fa);
	 fa := clone(model2fa);
	 test(fa,model2fa);
	 fa := clone(model3fa);
	 test(fa,model3fa);
	 fa := clone(model4fa);
	 test(fa,model4fa);

	 ll := clone(model1ll);
	 test(ll,model1ll);
	 ll := clone(model2ll);
	 test(ll,model2ll);
	 ll := clone(model3ll);
	 test(ll,model3ll);
	 ll := clone(model4ll);
	 test(ll,model4ll);

	 l2l := clone(model1l2l);
	 test(l2l,model1l2l);
	 l2l := clone(model2l2l);
	 test(l2l,model2l2l);
	 l2l := clone(model3l2l);
	 test(l2l,model3l2l);
	 l2l := clone(model4l2l);
	 test(l2l,model4l2l);
      end;

feature {NONE}

   model1a: ARRAY[INTEGER] is
      once
	 Result := <<6,7,8,9>>;
      end;

   model2a: ARRAY[INTEGER] is
      once
	 Result := <<1,2>>;
      end;

   model3a: ARRAY[INTEGER] is
      once
	 Result := <<-1,-3,6,7,8,9>>;
      end;

   model4a: ARRAY[INTEGER] is
      once
	 !!Result.make(2,1);
      end;

   model1fa: FIXED_ARRAY[INTEGER] is
      once
	 !!Result.with_capacity(4);
	 Result.add_last(6);
	 Result.add_last(7);
	 Result.add_last(8);
	 Result.add_last(9);
      end;

   model2fa: FIXED_ARRAY[INTEGER] is
      once
	 !!Result.with_capacity(2);
	 Result.add_last(1);
	 Result.add_last(2);
      end;

   model3fa: FIXED_ARRAY[INTEGER] is
      once
	 !!Result.with_capacity(6);
	 Result.add_last(-1);
	 Result.add_last(-3);
	 Result.add_last(6);
	 Result.add_last(7);
	 Result.add_last(8);
	 Result.add_last(9);
      end;

   model4fa: FIXED_ARRAY[INTEGER] is
      once
	 !!Result.make(0);
      end;

   model1ll: LINK_LIST[INTEGER] is
      once
	 !!Result.make;
	 Result.add_last(6);
	 Result.add_last(7);
	 Result.add_last(8);
	 Result.add_last(9);
      end;

   model2ll: LINK_LIST[INTEGER] is
      once
	 !!Result.make;
	 Result.add_last(1);
	 Result.add_last(2);
      end;

   model3ll: LINK_LIST[INTEGER] is
      once
	 !!Result.make;
	 Result.add_last(-1);
	 Result.add_last(-3);
	 Result.add_last(6);
	 Result.add_last(7);
	 Result.add_last(8);
	 Result.add_last(9);
      end;

   model4ll: LINK_LIST[INTEGER] is
      once
	 !!Result.make;
      end;

   model1l2l: LINK2_LIST[INTEGER] is
      once
	 !!Result.make;
	 Result.add_last(6);
	 Result.add_last(7);
	 Result.add_last(8);
	 Result.add_last(9);
      end;

   model2l2l: LINK2_LIST[INTEGER] is
      once
	 !!Result.make;
	 Result.add_last(1);
	 Result.add_last(2);
      end;

   model3l2l: LINK2_LIST[INTEGER] is
      once
	 !!Result.make;
	 Result.add_last(-1);
	 Result.add_last(-3);
	 Result.add_last(6);
	 Result.add_last(7);
	 Result.add_last(8);
	 Result.add_last(9);
      end;

   model4l2l: LINK2_LIST[INTEGER] is
      once
	 !!Result.make;
      end;

   test(c, model: COLLECTION[INTEGER]) is
      local
	 i1, i2: INTEGER;
      do
	 is_true(model.count = c.count);
	 from
	    i1 := c.lower;
	    i2 := model.lower;
	 until
	    i2 > model.upper
	 loop
	    is_true(c.item(i1) = model.item(i2));
	    i1 := i1 + 1;
	    i2 := i2 + 1;
	 end;
	 c.free;
      end;

   is_true(b: BOOLEAN) is
      do
	 cpt := cpt + 1;
	 if not b then
	    std_output.put_string("TEST_CLONE1: ERROR Test # ");
	    std_output.put_integer(cpt);
	    std_output.put_string("%N");
	 else
	    -- std_output.put_string("Yes%N");
	 end;
      end;
   
   cpt: INTEGER;
   
end -- TEST_CLONE1
