-- Part of SmallEiffel -- Read DISCLAIMER file -- Copyright (C) 
-- Dominique COLNET and Suzanne COLLIN -- colnet@loria.fr
--
class TEST_FORCE1

creation make
   
feature 
   
   make is
      local
	 a: ARRAY[INTEGER];
	 fa: FIXED_ARRAY[INTEGER];
	 ll: LINK_LIST[INTEGER];
	 l2l: LINK2_LIST[INTEGER];
      do
	 !!a.make(1,0);
	 test(a);
	 
	 !!fa.make(0);
	 test(fa);

	 !!ll.make;
	 test(ll);

	 !!l2l.make;
	 test(l2l);
      end;

feature {NONE}

   test(c: COLLECTION[INTEGER]) is
      require
	 c.empty
      local
	 low, up: INTEGER;
      do
	 low := c.lower;
	 up := low + 2;
	 c.force(3,up);
	 is_true(c.count = 3);
	 is_true(c.item(low) = 0);
	 is_true(c.item(low + 1) = 0);
	 is_true(c.item(up) = 3);
	 c.force(2,low + 1);
	 is_true(c.count = 3);
	 is_true(c.item(low) = 0);
	 is_true(c.item(low + 1) = 2);
	 is_true(c.item(up) = 3);

	 up := up + 1;
	 c.force(4,up);
	 is_true(c.item(up) = 4);
	 is_true(c.item(up - 1) = 3);
	 is_true(c.count = 4);

	 c.put(1,low);
	 is_true(c.item(low) = 1);
	 is_true(c.count = 4);

	 up := up + 3;
	 c.force(5,up);
	 is_true(c.item(up) = 5);
	 is_true(c.item(up - 1) = 0);
	 is_true(c.count = 7);
	 is_true(c.item(low) = 1);
	 
	 c.clear_all;
      end;

   is_true(b: BOOLEAN) is
      do
	 cpt := cpt + 1;
	 if not b then
	    std_output.put_string("TEST_FORCE1: ERROR Test # ");
	    std_output.put_integer(cpt);
	    std_output.put_string("%N");
	    crash;
	 else
	    -- std_output.put_string("Yes%N");
	 end;
      end;
   
   cpt: INTEGER;
   
end
