-- Part of SmallEiffel -- Read DISCLAIMER file -- Copyright (C) 
-- Dominique COLNET and Suzanne COLLIN -- colnet@loria.fr
--
class TEST_SLICE1

creation make
   
feature 
   
   make is
      local
	 model2: FIXED_ARRAY[INTEGER];
	 model3: ARRAY[INTEGER];
      do
	 test(<<1,2,3,4>>);

	 !!model2.from_collection(<<1,2,3,4>>);
	 test(model2);

	 !!model3.make(-2,1);
	 model3.put(1,-2);
	 model3.put(2,-1);
	 model3.put(3,0);
	 model3.put(4,1);
	 test(model3);
      end;

   test(model: COLLECTION[INTEGER]) is
      local
	 a: ARRAY[INTEGER];
	 fa: FIXED_ARRAY[INTEGER];
	 ll: LINK_LIST[INTEGER];
	 l2l: LINK2_LIST[INTEGER];
      do
	 !!a.from_collection(model);
	 test1(a);
	 a.free;

	 !!fa.from_collection(model);
	 test1(fa);
	 fa.free;

	 !!ll.from_collection(model);
	 test1(ll);
	 ll.free;

	 !!l2l.from_collection(model);
	 test1(l2l);
	 l2l.free;
      end;

feature {NONE}

   test1(model: COLLECTION[INTEGER]) is
      local
	 slice: like model;
      do
	 slice := model.slice(model.lower,model.lower);
	 is_true(slice.last = 1);
	 slice.free;

	 slice := model.slice(model.lower,model.lower + 1);
	 is_true(slice.first = 1);
	 is_true(slice.last = 2);
	 slice.free;

	 slice := model.slice(model.lower + 1,model.lower + 1);
	 is_true(slice.first = 2);
	 slice.free;

	 slice := model.slice(model.lower + 1,model.lower + 2);
	 is_true(slice.first = 2);
	 is_true(slice.last = 3);
	 slice.free;

	 slice := model.slice(model.upper,model.upper);
	 is_true(slice.last = 4);
	 slice.free;

	 slice := model.slice(model.upper - 1,model.upper);
	 is_true(slice.first = 3);
	 is_true(slice.last = 4);
	 slice.free;

	 slice := model.slice(model.lower,model.upper);
	 is_true(equal(slice,model));
	 slice.free;
      end;

feature {NONE}

   is_true(b: BOOLEAN) is
      do
	 cpt := cpt + 1;
	 if not b then
	    std_output.put_string("TEST_SLICE1: ERROR Test # ");
	    std_output.put_integer(cpt);
	    std_output.put_string("%N");
	 else
	    -- std_output.put_string("Yes%N");
	 end;
      end;
   
   cpt: INTEGER;
   
end -- TEST_SLICE1

